
require "amrita/template"

class MyTagClass
  attr_reader :name

  # ev[g̗vfƂɐB݌vsB
  def initialize(name, attrs)
    print "name = #{name}, id = #{__id__}\n"
    @name = name
    @attrs = attrs
  end

  def empty_tag?
    false
  end

  def start_tag?
    if @name == "html"
      return true
    elsif @name == "p"
      return true
    elsif @name == "tr"
      return true
    elsif @name == "td"
      return true
    else
      false
    end
  end

  def can_omit_endtag?
    true
  end

  # child_tagqvfƂ邩
  def accept_child(child_tag)
    if @name == "p"
      if child_tag == "p"
        return false 
      end
    elsif @name == "td"
      if child_tag == "td" || child_tag == "tr"
        return false
      end
    elsif @name == "tr"
      if child_tag == "tr"
        return false
      end
    end
    return true
  end

  def generate_element(parser)
    a = @attrs.collect {|attr| Attr.new(attr[0], attr[1])}
    return Amrita::Element.new(@name, *a) {parser.parse1(self)}
  end
end

class MyInfoItem
  def tag_class
    return MyTagClass
  end
end

class MyTagInfo
  def initialize
    @item = MyInfoItem.new
  end

  def get_tag_info(tagname)
    return @item
  end
end

def test2
  r = Amrita::HtmlParser.parse_text(<<EOF, nil, 0, MyTagInfo.new)
<tr><td>foo<td>bar<tr><td>hoge
EOF
  p r
end

test2()

=begin
Amrita 1.0.2 test2̎s
[ e(:tr) { [ e(:td) { "foo" }, e(:td) { "bar" } ] }, e(:tr) { e(:td) { "hoge\n" } } ]
    ok
=end
